package com.jasamedika.medifirst2000.controller;

import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.dto.PegawaiSkGajiDto;
import com.jasamedika.medifirst2000.service.PegawaiSKGajiService;
import com.jasamedika.medifirst2000.vo.PegawaiSKGajiVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

import static com.jasamedika.medifirst2000.core.web.WebConstants.HttpHeaderInfo.LABEL_SUCCESS;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonHttpStatus;
import static com.jasamedika.medifirst2000.util.rest.RestUtil.getJsonResponse;
import static org.springframework.http.HttpStatus.INTERNAL_SERVER_ERROR;
import static org.springframework.http.HttpStatus.OK;
import static org.springframework.http.MediaType.APPLICATION_JSON_VALUE;
import static org.springframework.web.bind.annotation.RequestMethod.GET;
import static org.springframework.web.bind.annotation.RequestMethod.POST;

@RestController
@RequestMapping(value = "/pegawai-sk-gaji")
public class PegawaiSkGajiController extends LocaleController<PegawaiSKGajiVO> {

	@Autowired
	private PegawaiSKGajiService pegawaiSKGajiService;

	@RequestMapping(value = "/save-pegawai-sk-gaji", method = POST, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> save(@RequestBody PegawaiSkGajiDto dto, HttpServletRequest request) {
		Map<String, Object> result = pegawaiSKGajiService.save(dto);
		if (!result.isEmpty()) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-pegawai-sk-gaji", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String, Object>> get(@RequestParam(value = "idPegawaiSkGaji") Integer idPegawaiSkGaji,
			HttpServletRequest request) {
		Map<String, Object> result = pegawaiSKGajiService.get(idPegawaiSkGaji);
		if (result != null) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

	@RequestMapping(value = "/get-pegawai-sk-gaji-by-pegawai-id", method = GET, produces = APPLICATION_JSON_VALUE)
	public ResponseEntity<List<Map<String, Object>>> getByPegawaiId(
            @RequestParam(value = "idPegawai") Integer idPegawai, HttpServletRequest request) {
		List<Map<String, Object>> result = pegawaiSKGajiService.getByPegawaiId(idPegawai);
		if (result != null) {
			mapHeaderMessage.put(LABEL_SUCCESS, getMessage(MessageResource.LABEL_SUCCESS, request));
			return getJsonResponse(result, OK, mapHeaderMessage);
		}
		return getJsonHttpStatus(INTERNAL_SERVER_ERROR, mapHeaderMessage);
	}

}
